#ifndef _MUTIPART_H_
#define _MUTIPART_H_
#include "common.h"
#define BUF_LEN 1000
#define MUL_ERROR -2
#define MUL_OK     2

#define CONTENT_DISPOSITION "Content-Disposition:"
#define CONTENT_TYPE "Content-Type:"
#define FORM_DATA "form-data;"
#define NAME "name"
#define FILE_NAME "filename"
typedef enum {
	state_seek_boundary = 0,
	state_after_boundary,
	state_headers,
	state_data,
	state_finish
}State;

typedef struct{
	char *header_name;
	int name_len;
	char *header_value;
	int value_len;

}sheader;
class CMultipart{

public:
	CMultipart();
	~CMultipart();
public:
	int parse_multipart_form_data(char*start,char*end);
	int parse_headers(char*start,char*end);
	int parse_headers_name(char*start,char*end);
	int set_boundary(char * boundary,int boundary_len);
	int disp_header_array();
	void set_store_file(char *file_path);
private:
	char mboundary[BUF_LEN];
	char *mboundary_pos;
	int mboundary_len;
	State mstate;
	char mheader_accumulator[BUF_LEN];
	sheader *mheader_array; //one char *array to record all multipart/form-data headers
	
	int mheader_sum;
	sheader *mtmp_header_array;
	char mheader_name_value[BUF_LEN];
	char *mheader_name_value_pos;
	int mheader_accumulator_len ;
	char *mheader_accumulator_pos;
	char * mheader_content_type;
	char * mfile_name;
	int mfile_name_len;

	int mis_file;
	int mfile_fd;
	char *mfile_path;
	int mfile_path_len;
};
#endif

